#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <values.h>
#include <string.h>
#include <unistd.h>
#include "error.h"
#include <float.h>
#include "apufunktiot.h"

#define round(X) floor((X)+.5)


float avgf(float *t,int l){
  int i;
  float sum=0.0;

  if (l==0) return 0.0;
  for (i=0;i<l;i++)
    sum+=t[i];
  return sum/l;
}

float avgint(int *t,int l){
  int i;
  float sum=0.0;
  if (l==0) return 0.0;

  for (i=0;i<l;i++)
    sum+=((float)t[i]);
  return sum/l;
}


/* average when index ind is excludes */
float exceptavgf(float *t,int l,int ind){
  int i;
  float sum=0.0;

  if ((l==1)||(l==0)) return 0.0; 
  for (i=0;i<l;i++){
    if (i!=ind)
      sum+=t[i];
  }

  return sum/(l-1);
}


/* suodattaa pois arvot, jotka <minth, jalj=jaljellee jaaneiden lkm */
float filteravgf(float *t,int l, int *jalj,float minth){
  int i;
  float sum=0.0;

  if (l==0){
    (*jalj)=0; 
    return 0.0;
  }
  (*jalj)=0;
  for (i=0;i<l;i++){
    if (t[i]>=minth){
      sum+=t[i];
      (*jalj)++;
    }
  }

  if ((*jalj)>0)
    return sum/(*jalj);
  else return 0.0;
}


/* sama mutta indeksi ind jatetaan huomiotta */
float exceptfilteravgf(float *t,int l, int *jalj,float minth, int ind){
  int i;
  float sum=0.0;

  if (l==0) return 0.0;
  (*jalj)=0;
  for (i=0;i<l;i++){
    if (((i!=ind)&&t[i]>=minth)){
      sum+=t[i];
      (*jalj)++;
    }
  }

  if ((*jalj)>0)
    return sum/(*jalj);
  else return 0.0;
}



float stdevf(float *t,int l,float avgx){
  int i;
  float sum=0.0;

  if (l==0) return 0.0;
  for (i=0;i<l;i++)
    sum+=pow((t[i]-avgx),2);
  return sqrt(sum/l);
}

float varf(float *t,int l,float avgx){
  int i;
  float sum=0.0;

  if (l==0) return 0.0;
  for (i=0;i<l;i++)
    sum+=pow((t[i]-avgx),2);
  return (sum/l);
}

/* Given two tables x and y of size l. Returns variance of y when */
/* a<x<=b. Updates the number of points in the interval. */ 
float varxf(float *x,float *y,int l,float a, float b, int *lkm){
  int i;
  float sum=0.0;
  float avg;

  (*lkm)=0;
  if (l==0) return 0.0;

  /* first avg */
  for (i=0;i<l;i++)
    if ((x[i]>=a)&&(x[i]<b)){
      sum+=y[i];
      (*lkm)++;
    }

  if ((*lkm)>1)
    avg=sum/(*lkm);
  else return 0.0; /* 0 or 1 data points */

  /* then var */
  sum=0.0;
  for (i=0;i<l;i++)
    if ((x[i]>a)&&(x[i]<=b))
      sum+=pow((y[i]-avg),2);
  
  return (sum/(*lkm));

}


/* Given two tables x and y of size l. Returns mean of y when */
/* a<x<=b. Updates the number of points in the interval. */ 
float avgxf(float *x,float *y,int l,float a, float b, int *lkm){
  int i;
  float sum=0.0;

  (*lkm)=0;
  if (l==0) return 0.0;

  for (i=0;i<l;i++)
    if ((x[i]>=a)&&(x[i]<b)){
      sum+=y[i];
      (*lkm)++;
    }

  if ((*lkm)>0)
    return (sum/(*lkm));
  else return 0.0;
}


/* Korrelaatioratio annettuna diskretointivalin koko. */
/* tss kaava tarkistettu! Olettaa etta osavalit samankokoisia. */
float corrratio2(float *x, float *y, int l, float ival){
  float min=minf(x,l);
  float max=maxf(x,l);
  int i,ni;
  int nmin=INT_MAX; int nmax=0; /* for statistics; numbers of points in an */
  /* interval */
  int ny=0; /* number of data points */
  float sum=0.0;
  int nI=0; /* number of intervals */
  float avgy,avg=avgf(y,l);
  float var=varf(y,l,avg);

  nI=(max-min)/ival;
  if (((max-min)-nI*ival)>0.0)
    nI++; /* extra interval for the rest */

  for (i=0;i<nI;i++){
    if (i==0)
      avgy=avgxf(x,y,l,min-0.000001,min+ival,&ni); /* allow inprecision */
    else { 
      if (i<nI-1)
	avgy=avgxf(x,y,l,min+i*ival,min+(i+1)*ival,&ni);
	else avgy=avgxf(x,y,l,min+i*ival,min+(i+1)*ival+0.000001,&ni);
    }
    sum+=ni*(avgy-avg)*(avgy-avg);


    if (ni==0) printf("no points when %.2f<=x<%2f\n",min+i*ival,min+(i+1)*ival);


    if ((i>0)&&(i<nI-1)){ /* statistics excluding the first and last interval */
      if (ni<nmin) nmin=ni;
      if (ni>nmax) nmax=ni;
    }
  }

  printf("An interval of size %.2f contained %d ... %d points (excluding the first and \nthe last interval) (avg=%d points).\n",ival,nmin,nmax,ny/nI);

  return sqrt(sum/(l*var));


}

/* suodattaa pois arvot, jotka <minth */
float filterstdevf(float *t,int l,float avgx, float minth){
  int i,jalj=0;
  float sum=0.0;

  if (l==0) return 0.0;
  for (i=0;i<l;i++)
    if (t[i]>=minth){
    sum+=pow((t[i]-avgx),2);
    jalj++;
  }
  if (jalj>0)
    return sqrt(sum/jalj);
  else return 0.0;
}

/* sama mutta indeksi ind jatetaan huomiotta */
float exceptfilterstdevf(float *t,int l,float avgx, float minth, int ind){
  int i,jalj=0;
  float sum=0.0;

  if (l==0) return 0.0;
  for (i=0;i<l;i++)
    if ((i!=ind)&&(t[i]>=minth)){
    sum+=pow((t[i]-avgx),2);
    jalj++;
  }
  if (jalj>0)
    return sqrt(sum/jalj);
  else return 0.0;
}



float exceptstdevf(float *t,int l,float avgx, int ind){
  int i,jalj=0;
  float sum=0.0;

  if (l==0) return 0.0;
  for (i=0;i<l;i++)
    if ((i!=ind)){
    sum+=pow((t[i]-avgx),2);
    jalj++;
  }
  if (jalj>0)
    return sqrt(sum/jalj);
  else return 0.0;
}


float kurtosisf(float *t, int l, float avgx, float stdevx){
  int i;
  float sum=0.0;
  /* erikoistapaus, jos stdev=0 */
  if (stdevx<=0.00001)
    return 0.0;
  
  for (i=0;i<l;i++)
    sum+=pow(t[i]-avgx,4);

  return (sum/(l*pow(stdevx,4))-3.0);
}

float skewf(float *t, int l, float avgx, float stdevx){
  int i;
  float sum=0.0;
  /* erikoistapaus, jos stdev=0 */
  if (stdevx<=0.00001)
    return 0.0;
  
  for (i=0;i<l;i++)
    sum+=pow(t[i]-avgx,3);

  return (sum/(l*pow(stdevx,3)));
}




double maxd(double *t,int l){
  double m=-1*(DBL_MAX-1);
  int i;
  for (i=0;i<l;i++)
    if (t[i]>m) m=t[i];

  return m;
}



float maxf(float *t,int l){
  float m=-1*(FLT_MAX-1);
  int i;
  for (i=0;i<l;i++)
    if (t[i]>m) m=t[i];

  return m;
}



float maxfjasij(float *t,int size, int *sij){
  float m=-1*(FLT_MAX-1);
  int i;
  for (i=0;i<size;i++)
    if (t[i]>m){ 
      m=t[i];
      (*sij)=i;
    }

  return m;
}

float minfjasij(float *t,int size, int *sij){
  float m=FLT_MAX;
  int i;
  for (i=0;i<size;i++)
    if (t[i]<m){ 
      m=t[i];
      (*sij)=i;
    }

  return m;
}




/* search l:th maximum value  */
float lthmaxfjasij(float *t,int size, int l, int *sij){
  float m=-1*(FLT_MAX-1);
  int i,j,ind=-1;
  float *tmp;

  if ((tmp=(float*)malloc(size*sizeof(float)))==NULL)
    error(6);
  for (i=0;i<size;i++)
    tmp[i]=t[i];

  for (j=0;j<l;j++){
    m=-1*(FLT_MAX-1);
    if (ind>-1) /* poista ed. kierroksen maksimi */
      tmp[ind]=-1*(FLT_MAX-1);
    for (i=0;i<size;i++)
      if (tmp[i]>m){ 
	m=tmp[i];
	ind=i;
      }
  }
  (*sij)=ind;
  return m;
}


/* luo jarjestetty kopio annetusta int-taulusta */
int *sort(int *t, int size){
  int min,sij,apu;
  int i,next=0;
  int *tmp;

  if ((tmp=(int*)malloc(size*sizeof(int)))==NULL)
    error(6);
  for (i=0;i<size;i++)
    tmp[i]=t[i];
  while (next<size-1){
    min=tmp[next]; sij=next;
    for (i=next+1;i<size;i++){
      if (tmp[i]<min){
	min=tmp[i];
	sij=i;
      }
    } /* for */
    /* nyt swappaa */
    apu=tmp[next];
    tmp[next]=min;
    tmp[sij]=apu;
    next++;
  }
  return tmp;
}

/* ei ihan oikea maar. poistaa myos duplikaatit */
/* etsi int-taulun mediaani eli keskimmainen arvo */
/* lisaa tilanvap! */
int omamedian(int *t, int size){
  int *tmp;
  int min=0; int max=size-1; /* eka ja viim. indeksi */

  /* erikoistapaus */
  if (size==0)
    return 0; /* onko jarkevaa? pitaisi olla erikseen virhekoodi */

  /* ensin jarjestetty kopio t:sta */
  tmp=sort(t,size);
  
  while (min<max){
    if (tmp[min]==tmp[max]) /* sama arvo */
      return tmp[min]; 
    /* "poista" pienin ja sen duplikaatit alusta */
    while (tmp[min]==tmp[min+1])
      min++;
    /* siirra indeksi seuraavaan, jossa jo eri arvo */
    min++;
    if (tmp[min]==tmp[max]) /* sama arvo */
      return tmp[min]; 
    /* "poista" suurin ja sen duplikaatit lopusta */
    while (tmp[max]==tmp[max-1])
      max--;
    /* siirra indeksi edellisee, jossa jo eri arvo */
    max--;
    /* jos menivat samoiksi, selviaa seuraavan while alussa */
  }

  /* nyt samat */
  return tmp[min];
}


/* kuten ed, mutta mutta t tyyppia float; ovat silti kok.lukuja */
/* jos eivat ole, niin pyoristaa! */
int *sort2(float *t, int size){
  int min,sij,apu;
  int i,next=0;
  int *tmp;

  if ((tmp=(int*)malloc(size*sizeof(int)))==NULL)
    error(6);
  for (i=0;i<size;i++)
    tmp[i]=round(t[i]);
  while (next<size-1){
    min=tmp[next]; sij=next;
    for (i=next+1;i<size;i++){
      if (tmp[i]<min){
	min=tmp[i];
	sij=i;
      }
    } /* for */
    /* nyt swappaa */
    apu=tmp[next];
    tmp[next]=min;
    tmp[sij]=apu;
    next++;
  }
  return tmp;
}


/* sort kun aitoja floateja */
float *sortf(float *t, int size){
  float min,apu;
  int i,sij,next=0;
  float *tmp;

  if ((tmp=(float*)malloc(size*sizeof(float)))==NULL)
    error(6);
  for (i=0;i<size;i++)
    tmp[i]=t[i];
  while (next<size-1){
    min=tmp[next]; sij=next;
    for (i=next+1;i<size;i++){
      if (tmp[i]<min){
	min=tmp[i];
	sij=i;
      }
    } /* for */
    /* nyt swappaa */
    apu=tmp[next];
    tmp[next]=min;
    tmp[sij]=apu;
    next++;
  }
  return tmp;
}


/* kuten ed., mutta t tyyppia float; ovat silti kok.lukuja */
/* lisaa tilanvap! */
int omamedian2(float *t, int size){
  int *tmp;
  int min=0; int max=size-1; /* eka ja viim. indeksi */

  /* erikoistapaus */
  if (size==0)
    return 0; /* onko jarkevaa? pitaisi olla erikseen virhekoodi */

  /* ensin jarjestetty kopio t:sta */
  tmp=sort2(t,size);
  
  while (min<max){
    if (tmp[min]==tmp[max]) /* sama arvo */
      return tmp[min]; 
    /* "poista" pienin ja sen duplikaatit alusta */
    while (tmp[min]==tmp[min+1])
      min++;
    /* siirra indeksi seuraavaan, jossa jo eri arvo */
    min++;
    if (tmp[min]==tmp[max]) /* sama arvo */
      return tmp[min]; 
    /* "poista" suurin ja sen duplikaatit lopusta */
    while (tmp[max]==tmp[max-1])
      max--;
    /* siirra indeksi edellisee, jossa jo eri arvo */
    max--;
    /* jos menivat samoiksi, selviaa seuraavan while alussa */
  }

  /* nyt samat */
  return tmp[min];
}


/* kuten ed. mutta oikea mediaani! */
int median2(float *t, int size){
  int *tmp;
  int med;

  /* erikoistapaus */
  if (size==0)
    return 0; /* onko jarkevaa? pitaisi olla erikseen virhekoodi */

  /* ensin jarjestetty kopio t:sta */
  tmp=sort2(t,size);
  
  /* jos pariton koko, niin keskimm. arvo, muuten pienempi keskimmaisista */
  if (size%2==0)
    med=tmp[size/2-1];
  else med=tmp[(size+1)/2-1];

  free(tmp);
  return med;
}



/* mediaani kun oikeasti floateja */
float medianf(float *t, int size){
  float *tmp;
  float med;

  /* erikoistapaus */
  if (size==0)
    return 0; /* onko jarkevaa? pitaisi olla erikseen virhekoodi */

  /* ensin jarjestetty kopio t:sta */
  tmp=sortf(t,size);
  
  /* jos pariton koko, niin keskimm. arvo, muuten keskiarvo */
  if (size%2==0)
    med=tmp[(size+1)/2-1];
  else med=(tmp[size/2-1]+tmp[size/2])/2.0;

  free(tmp);
  return med;
}

/* poikkeamien nelioiden mediaanin neliojuuri, mediaanivastine stdeville */
float meddevf(float *t, int size,float med){
  float *tmp;
  float meddev=0.0;
  int i;

  if ((tmp=(float*)malloc(size*sizeof(float)))==NULL)
    error(6);
  /* aputauluun neliopoikkeamat mediaanista */
  for (i=0;i<size;i++)
    tmp[i]=pow(t[i]-med,2);
  /* naiden mediaani */
  meddev=medianf(tmp,size);
  free(tmp);
  /* palauta meddevin neliojuuri */
  return sqrt(meddev);
}


double mind(double *t,int l){
  double m=DBL_MAX;
  int i;
  for (i=0;i<l;i++)
    if (t[i]<m) m=t[i];

  return m;
}


float minf(float *t,int l){
  float m=FLT_MAX;
  int i;
  for (i=0;i<l;i++)
    if (t[i]<m) m=t[i];
  
  return m;
}


/* Pearsonin korrelaatiokerroin */
float corr(float *x, float *y, float mux, float stdevx, float muy, float stdevy, int n){
  float sum=0.0;
  int i;

  /* erikoistapaus jos stdev==0 */
  if ((stdevx<=0.0000001)||(stdevy<=0.0000001))
    {
      if ((stdevx<=0.0000001)&&(stdevy<=0.0000001))
	return 1.0;
      else return 0.0; /* vain toinen stdev=0. Onko ok? */
    }


  for (i=0;i<n;i++)
    sum+=(x[i]-mux)*(y[i]-muy);
  return sum/((float)n*stdevx*stdevy);

}



/* 1-arvojen osuus kaikista */
float osuusd(double *t,int l){
  int lkm=0;
  int i;
  for (i=0;i<l;i++)
    if (t[i]>0.0) lkm++;

  return ((float)lkm)/l;
}


/* taulukon 1. indeksi jossa arvo >=0; -1 jos ei loydy */
 int ekaarvof(float *t,int l){
   int i;
   for (i=0;i<l;i++)
     if (t[i]>=0) break;

   if (i<l-1) return i;
   else{ 
     if (t[l-1]>=0) return l-1;
     else return -1; 
   }
 }


/* palauttaa viimeisen indeksin jossa arvo >-FLT_MAX ja -1 jos ei lydy */
int vikaarvof(float *t, int l){
  int i;

  for (i=l-1;i>=0;i--)
    if (t[i]>-1.0*FLT_MAX) break;

  if (i>0) return i;
  /* jos tuli taulukon alkuun */
  if (t[0]>-1.0*FLT_MAX) return 0;
  else return -1;
}



/* laskee rivien lkm:n tiedostossa */
int nofrows(FILE *f){
  int lkm=0;
  char *row;

  if ((row=(char*)malloc(6000))==NULL) error(6);

  while (fgets(row, 6000, f)!=NULL)
      lkm++;

  rewind(f);

  return lkm;
}

/* maksim sarakkeiden lkm kun erotin space */
int nofcols(FILE *f){
  int i,len,lkm;
  char *row;
  int maxlkm=0;


  if ((row=(char*)malloc(6000))==NULL) error(6);

  while (fgets(row, 6000, f)!=NULL){
    len=strlen(row);
    lkm=0; i=0;
    while (i<len){
      while (row[i]==' ') i++;
      if ((i<len)&&(row[i]!=' ')&&(row[i]!='\n')){
	lkm++;
      }
      while ((i<len)&&(row[i]!=' '))
	i++;
    }
    if (lkm>maxlkm) maxlkm=lkm;
  } /* while */

  rewind(f);

  return maxlkm;
}


/* tarkista ettei taulussa nan:eja tai infeja; jos ok, palauta 1 */
int tarkistataulu(float *t, int size){
  int i;

  for (i=0;i<size;i++)
    if (isfinite(t[i])==0){
      printf("Virheellinen lukuarvo positiossa %d (nan tai inf)\n",i);
      return 0;
    }

  return 1;
}


/* siirtaa arvot -FLT_MAX loppuun ja palauttaa niiden lkm joissa oikea arvo */
int siirrapuuttuvat(float *t, int l){
  int i, ind;
  int viim=l;

  for (i=0;i<l;i++)
    if (t[i]<=-1.0*FLT_MAX){
      ind=vikaarvof(t,viim);
      if ((ind<=0)||(ind<i)) /* ei en siirtmist */
	break;
      else {
	t[i]=t[ind];
	t[ind]=-1.0*FLT_MAX;
	viim=ind;
      }
    }

  return i;
}



/* luo uuden taulukon, johon sijoittaa normalisoidut arvot */
float *normalisoi(float *t,int l){
  float ka, khaj;
  int i;
  float *ut;

  if ((ut=(float*)malloc(l*sizeof(float)))==NULL) error(6);

  ka=avgf(t,l);
  khaj=stdevf(t,l,ka);
  if (khaj==0.0) 
    for (i=0;i<l;i++)
      ut[i]=0.0;
  else 
    for (i=0;i<l;i++)
      ut[i]=(t[i]-ka)/khaj;

  return ut;
}

float sumf(float *t, int l){
  float sum=0.0;
  int i;
  for (i=0;i<l;i++)
    sum+=t[i];
  return sum;
}

/* moniko ylitt raja-arvon thr? */
int aktlkm(float *t, int l, float thr){
  int i;
  int lkm=0;
  for (i=0;i<l;i++)
    if (t[i]>=thr)
      lkm++;
  return lkm;
}




void printvector(float *t,int l){
  int i;

  for (i=0;i<l;i++)
    printf("%.2f ",t[i]);
  printf("\n");
}

void printvector2(float *t,int l){
  int i;

  if (l>0)
    printf("%.2f",t[0]);
  for (i=1;i<l;i++)
    printf(",%.2f",t[i]);
}



void printtable(float **t, int riv, int sar){
  int i,j;

  for (i=0;i<riv;i++){
    printf("%d ",i);
    for (j=0;j<sar;j++)
      printf("%.2f ",t[i][j]);
    printf("\n");
  }
}


void printinttable(int **t, int riv, int sar){
  int i,j;

  for (i=0;i<riv;i++){
    printf("%d ",i);
    for (j=0;j<sar;j++)
      printf("%d ",t[i][j]);
    printf("\n");
  }
}

/* tulosta ne rivit joilla attr l arvo > thr */
void selprinttable(float **t, int riv, int sar, int l, float thr){
  int i,j;

  for (i=0;i<riv;i++){
    if (t[i][l]>thr){
      printf("%d ",i);
      for (j=0;j<sar;j++)
	printf("%.2f ",t[i][j]);
      printf("\n");
    }
  }
}

/* diskretoi tasavliseksi ja korvaa numeer. arvon jrjestysluvulla */
/* Sytetaulu t, tulostaulu v, pit l */
void diskretoi(float *t,int l,int **v,float ival){
  float min=minf(t,l);
  float max=maxf(t,l);
  int i,j,ni;
  int nmin=INT_MAX; int nmax=0; /* for statistics; numbers of points in an */
  /* interval */
  int ny=0; /* number of data points */
  int nI=0; /* number of intervals */

      printf("Range [%.3f,%.3f]\n",min,max);

  nI=(max-min)/ival;
  if (((max-min)-nI*ival)>0.0)
    nI++; /* extra interval for the rest */

  if (((*v)=(int*)malloc(l*sizeof(int)))==NULL)
    error(6);

  for (i=0;i<l;i++){
    (*v)[i]=(t[i]-min)/ival;
  }


  for (i=0;i<nI;i++){
    ni=0;
    for (j=0;j<l;j++)
      if ((*v)[j]==i)
	ni++;

    /*  printf("%d points when %.2f<=t<%2f\n",ni,min+i*ival,min+(i+1)*ival);*/
     printf("%.2f %d\n",min+i*ival+ival/2.0,ni);

    if ((i>0)&&(i<nI-1)){ /* statistics excluding the first and last interval */
      if (ni<nmin) nmin=ni;
      if (ni>nmax) nmax=ni;
    }
    ny+=ni;
  }
  
  /*  printf("An interval of size %.2f contained %d ... %d points (excluding the first and \nthe last interval) (avg=%d points).\n",ival,nmin,nmax,ny/nI);*/

}


int concordantpairs(int *x, int *y, int l){
  int i,j;
  int signx, signy;
  int lkm=0;

  for (i=0;i<l-1;i++)
    for (j=i+1;j<l;j++){
      if (x[i]>=x[j]) /* huom! yhtsuuruus */
	signx=1;
      else signx=-1;
      if (y[i]>=y[j])
	signy=1;
      else signy=-1;
      lkm+=(signx*signy);
    }

  /*  printf("taun osoittaja %d (pareja %d)\n",lkm,l*(l-1));*/

  return lkm;
}

float kendalltau(int *x, int *y, int l){

  if (l<=1) return 1.0;
  return ((2.0*concordantpairs(x,y,l))/(((float)l)*(l-1)));
}

int concordantpairsf(float *x, float *y, int l){
  int i,j;
  int signx, signy;
  int lkm=0;

  for (i=0;i<l-1;i++)
    for (j=i+1;j<l;j++){
      if (x[i]>=x[j]) /* huom! yhtsuuruus */
	signx=1;
      else signx=-1;
      if (y[i]>=y[j])
	signy=1;
      else signy=-1;
      lkm+=(signx*signy);
    }

  /*  printf("taun osoittaja %d (pareja %d)\n",lkm,l*(l-1));*/

  return lkm;
}


/* em siten ett tutkitaan X_i=x_j erikseen */
int concordantpairsfv3(float *x, float *y, int l){
  int i,j;
  int signx, signy;
  int lkm=0;

  for (i=0;i<l-1;i++)
    for (j=i+1;j<l;j++){
      if (x[i]>x[j]) 
	signx=1;
      else {
	if (x[i]<x[j]) 
	  signx=-1;
	else signx=0;
      }
      if (y[i]>y[j])
	signy=1;
      else {
      if (y[i]<y[j])
	signy=-1;
      else signy=0;
      }
      if (signx==signy)
	lkm++;
      else lkm--;
    }

  /*  printf("taun osoittaja %d (pareja %d)\n",lkm,l*(l-1));*/

  return lkm;
}


/* Tm perint. tavalla eli "sidottuja" ei summiin. */
int concordantpairsfv2(float *x, float *y, int l){
  int i,j;
  int signx, signy;
  int lkm=0;

  for (i=0;i<l-1;i++)
    for (j=i+1;j<l;j++){
      if (x[i]>x[j]) 
	signx=1;
      else {
	if (x[i]<x[j]) 
	  signx=-1;
	else signx=0;
      }

      if (y[i]>y[j])
	signy=1;
      else {
	if (y[i]<y[j])
	  signy=-1;
	else signy=0;
      }

      lkm+=(signx*signy);
    }

  /*  printf("taun osoittaja %d (pareja %d)\n",lkm,l*(l-1));*/

  return lkm;
}


float kendalltauf(float *x, float *y, int l){

  if (l<=1) return 1.0;
  return ((2.0*concordantpairsfv3(x,y,l))/(((float)l)*(l-1)));
}



float spearmanrhof(float *x,float *y,int l){
  float *xrank,*yrank,*tmp;
  int i,j,lkm,sij;
  float min,edmin,sum;
  float mux,muy,stdevx,stdevy,rho;
  float next,uusirank;

  if ((tmp=(float*)malloc(l*sizeof(float)))==NULL)
    error(6);

  if ((xrank=(float*)malloc(l*sizeof(float)))==NULL)
    error(6);
  if ((yrank=(float*)malloc(l*sizeof(float)))==NULL)
    error(6);
  for (i=0;i<l;i++){
    xrank[i]=-1.0; yrank[i]=-1.0;
  }

  /* laske rankit x:n ja y:n alkioille */


  for (i=0;i<l;i++)
    tmp[i]=x[i]; /* kopio */

  min=(-1)*FLT_MAX+1; edmin=(-1)*FLT_MAX; 
  next=1.0; /* rank-numero */
  lkm=0; /* montako samaa arvoa perkkin */
  for (i=0;i<l;i++){
    min=minfjasij(tmp,l,&sij);
    tmp[sij]=FLT_MAX;
    if ((min>edmin)&&(lkm>1)){ /* korjattava ed. rankit jotka yhta isoja */
      sum=0.0;
      for (j=next-lkm-1.0;j<=next-1.0;j++)
	sum+=j;
      uusirank=sum/lkm;
      for (j=0;j<l;j++)
	if ((xrank[j]>=next-lkm-1.000001)&&(xrank[j]<=next-0.99999))
	  xrank[j]=uusirank;
      lkm=0;
    }
    /* aina sijoita normaali rank seuraavalle */
    xrank[sij]=next;
    next+=1.0;
    lkm++;
    edmin=min;
  } /* for i */


  for (i=0;i<l;i++)
    tmp[i]=y[i]; /* kopio */

  min=(-1)*FLT_MAX+1; edmin=(-1)*FLT_MAX; 
  next=1.0; /* rank-numero */
  lkm=0; /* montako samaa arvoa perkkin */
  for (i=0;i<l;i++){
    min=minfjasij(tmp,l,&sij);
    tmp[sij]=FLT_MAX;
    if ((min>edmin)&&(lkm>1)){ /* korjattava ed. rankit jotka yhta isoja */
      sum=0.0;
      for (j=next-lkm-1.0;j<=next-1.0;j++)
	sum+=j;
      uusirank=sum/lkm;

      for (j=0;j<l;j++)
	if ((yrank[j]>=next-lkm-1.000001)&&(yrank[j]<=next-0.99999))
	  yrank[j]=uusirank;
      lkm=0;
    }
    /* aina sijoita normaali rank seuraavalle */
    yrank[sij]=next;
    next+=1.0;
    lkm++;
    edmin=min;
  } /* for i */





  /*  for (i=0;i<l;i++)
    printf("%.1f ",xrank[i]);
  printf("\n");
  for (i=0;i<l;i++)
    printf("%.1f ",xrank[i]);
    printf("\n");*/

  /* sitten laske pearsonin korrelaatio rank-tauluille */
  
  mux=avgf(xrank,l);
  muy=avgf(yrank,l);
  stdevx=stdevf(xrank,l,mux);
  stdevy=stdevf(yrank,l,muy);
  rho=corr(xrank,yrank,mux,stdevx,muy,stdevy,l);
  
  free(xrank); free(yrank); free(tmp);
  return rho;
}
