#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include "data.h"
#include "error.h"
#include "apufunktiot.h"

int ALKU=1;
int LOPPU=30;

int main(int argc,char**argv){
  FILE *f=NULL;
  int d;
  float **data;
  float stdev, mu,sum=0.0;
  int i,opt,n;

  if (argc<3){
    error(9);
  }

 while ((opt=getopt(argc,argv,"i:d:"))!=-1){
    switch(opt){
    case 'i':  printf("Input file [%s]\n",optarg);
      if ((f=fopen(optarg,"r"))==NULL)
        error(1);
      break; 
    case 'd': d=atol(optarg);
      if (d<=0){ printf("Lag d should be positive integer\n");
	error(9);
      }
      break;
    }
 }

  readdata(f,&data,1,&n);
  
  if(fclose(f)==EOF)
    error(4);

  mu=avgf(data[0],n);
  stdev=stdevf(data[0],n,mu);
  if (stdev<0.000001){
    printf("Cannot determine autocorrelation: stdev=0.0\n");
       return EXIT_SUCCESS;
  }

  printf("avg=%.2f stdev=%.3f\n",mu,stdev);

  for (d=ALKU;d<=LOPPU;d++){
    sum=0.0;
    for (i=0;i<n-d;i++)
      sum+=(data[0][i]-mu)*(data[0][i+d]-mu);
    
    printf("%d %.3f\n",d,((float)sum)/(((float)n-d)*stdev*stdev));
  }


   return EXIT_SUCCESS;
}
