#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "data.h"
#include "apufunktiot.h"
#include "error.h"


/* read the first COL floats into table t */ 

void readdata(FILE *f, float ***t,int COL,int *n){

  char *row, *tmp;
  char *endp;
  int i,j,next;
  int LLEN=10000;
  float v;

  /* number of rows in the file */
  (*n)=nofrows(f);

  /* create COL rows, each with *n columns */
  if ((*t=(float**)malloc(COL*sizeof(float*)))==NULL)
    error(6);
  
  for (i=0; i<COL; i++) {
    if (((*t)[i]=(float*)malloc((*n)*sizeof(float)))==NULL)
      error(6);
    for (j=0;j<(*n);j++)
      (*t)[i][j]=0.0;
  }

  if ((row=(char*)malloc(LLEN))==NULL) error(6); 

  next=0;
  while (next<*n) {
    if (fgets(row, LLEN, f)==NULL)
      error(5);
    /* read the first COL values into table t */
    tmp=row;
    for (i=0;i<COL;i++){
      v=strtof(tmp, &endp); 
       if (endp==row){
	 if (*tmp=='\n') break;
	 else {
	   printf("Error on line %d attr. %d (%s)\n",next+1,i+1,tmp);
	   error(5);
	 }
       }
       tmp=endp;
       (*t)[i][next]=v;
       if ((*tmp==',')||(*tmp==' ')) /* one separator */
          tmp++;
    } /* for COL first fields */
    next++;

  }

  free(row);

}


